﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CalculatorLibrary;
using CommandParserLibrary;
using InputOutputLibrary;
using System.Runtime.CompilerServices;

namespace Application
{
  public class CalcutorReplLoop : ICalcutorReplLoop
  {
    #region 构造函数

    public CalcutorReplLoop(ICalculator calculator, IInputParserService parserService,
        IInputService inputService, IOutputService outputService)
    {
      this.calculator = calculator;
      this.parsingService = parserService;
      this.inputService = inputService;
      this.outputService = outputService;
    }

    #endregion

    #region 字段

    ICalculator calculator;
    IInputParserService parsingService;
    IInputService inputService;
    IOutputService outputService;

    #endregion

    #region 属性
    public ICalculator Calculator
    {
      get { return calculator; }
      set { calculator = value; }
    }

    public IInputParserService ParsingService
    {
      get { return parsingService; }
      set { parsingService = value; }
    }

    public IInputService InputService
    {
      get { return inputService; }
      set { inputService = value; }
    }

    public IOutputService OutputService
    {
      get { return outputService; }
      set { outputService = value; }
    }
    #endregion

    public void Run()
    {
      while (true)
      {
        string command = inputService.ReadCommand();

        try
        {
          CommandTypes commandType = parsingService.ParseCommand(command);

          Arguments args = inputService.ReadArguments();

          outputService.WriteMessage(
              calculator.Execute(commandType, args).ToString());
        }
        catch
        {
          outputService.WriteMessage("Mistake!");
        }
      }
    }
  }
}
